
public class StackTest
{
    public static double sumElements(GenericStack<? extends Number> stack)
    {
        double sum = 0.0;
        
        while(!stack.isEmpty())
        {
            sum += stack.pop().doubleValue();
        }
        
        return sum;
    }
    
    //public static <T> void moveElements(GenericStack<T> source, GenericStack<? super T> dest)
    public static <T> void moveElements(GenericStack<? extends T> source, GenericStack<T> dest)
    {
        while(!source.isEmpty())
        {
            dest.push(source.pop());
        }
            
    }
    
    public static void main(String[] args)
    {
        GenericStack<Integer> s1 = new GenericStack<Integer>(10);
        s1.push(5); 
        s1.push(42);
        s1.push(1138);
        
        s1.displayState();
        
        //System.out.println("out:" + sumElements(s1));
        
        GenericStack<Integer> s2 = new GenericStack<Integer>(15);
        s2.displayState();
        
        moveElements(s1, s2);
        
        s2.displayState();
        
        GenericStack<Number> s3 = new GenericStack<Number>(20);
        s3.push(new Integer(4));
        s3.push(new Double(1.2));
        s3.push(2.4);
        int a = 42;
        s3.push(a);
        
        moveElements(s2, s3);
        
        s3.displayState();
        
        /*
        GenericStack<Double> s2 = new GenericStack<Double>(15);
        s2.push(1.2);
        s2.push(3.7);
        s2.push(2.1);
        System.out.println("out:" + sumElements(s2));
        */
        
    }

}
